#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "listas.h" 	
#include "colas.h"
#include "pilas.h"
#include "abdb.h"
 	

/* Ejercicio Recorrer arboles en profundidad preorden */
int RecorrerEnProfundidadPreOrden (Arbol ab, Cola *resultado)
{
		
}

/* Ejercicio Recorrer arboles en profundidad en orden */ 	
int RecorrerEnProfundidadEnOrden (Arbol ab, Cola *resultado)
{
}
/* Ejercicio Recorrer arboles en profundidad postorden */
int RecorrerEnProfundidadPostOrden (Arbol ab, Cola *resultado)
{
}

/* Ejercicio Calcular nodos internos */
int CalcularNodosInternos (Arbol ab)
{
}

/* Ejercicio Calcular altura*/

int CalcularAltura(Arbol ab)
{
}

/* Ejercicio Calcular nº de elementos */
int CalcularNElementos(Arbol ab)
{
}

/* Ejercicio Calcular equilibrio */
int CalcularEquilibrio(Arbol ab)
{
}


/* Ejercicio Altura mínima */
int CalcularAlturaMinima(Arbol ab)
{
}

/* Ejercicio Crear lista con hermanos */
int CrearListaConHermanos(Arbol ab, Lista resultado)
{
}
/* Ejercicio Crear lista con hojas */
int CrearListaConHojas(Arbol ab, Lista lista)
{
}

/* Ejercicio Crear lista con padres */
int CrearListaConInternos(Arbol ab, Lista lista)
{
}

/* Ejercicio  Recorrer arboles en anchura.
   Para este ejercicio es necesario usar una cola auxiliar para guardar los
   punteros a la raíz y nodos hijos que se van a visitar. Para ello vamos a usar
   un TAD cola que guarda punteros en vez de enteros (ficheros colasP.c y .h).
   Para encolar y desencolar un elemento en esta cola se hace del siguiente modo:
 
      Arbol a;
      ...
      a = ...
      ...
      encolarP(a, C);
      ...
      while(!esVaciaColaP(*cola)) {
        ...
        a = (Arbol)primeroP(*cola);
        ...
      }

*/
int RecorrerEnAnchura (Arbol ab, Cola *resultado)
{
}

/*
 * PRUEBAS 
 */ 
int main ()
{
	Arbol ab;
	Lista lista;
	Cola *cola;
	
	// Inicialización
	ab = crearArbol();
	lista = crearLista();
	
	//Incluir datos para reflejar el árbol del enunciado
	ab = insertarDato(3, ab);
	ab = insertarDato(1, ab);
	ab = insertarDato(6, ab);
	ab = insertarDato(2, ab);
	ab = insertarDato(5, ab);
	ab = insertarDato(7, ab);
	ab = insertarDato(4, ab);
	
	// Ejecutamos los tests
	printf ("En anchura 3 1 6 2 5 7 4\n");
	cola = crearCola();
	RecorrerEnAnchura (ab, cola);
	imprimirCola(cola);
	borrarCola(cola);
	
	cola = crearCola();
	printf ("Profundidad pre orden 3 1 2 6 5 4 7 \n");	
	RecorrerEnProfundidadPreOrden (ab, cola); 
	imprimirCola(cola);
	borrarCola(cola);
	
	cola = crearCola();
	printf ("Profundidad en orden 1 2 3 4 5 6 7 \n");	
	RecorrerEnProfundidadEnOrden (ab, cola);
	imprimirCola(cola);
	borrarCola(cola);
	
	cola = crearCola();
	printf ("Profundidad post orden 2 1 4 5 7 6 3 \n");	
	RecorrerEnProfundidadPostOrden (ab, cola);
	imprimirCola(cola);
	borrarCola(cola);
	
	printf ("Nodos internos 4 = %d\n", CalcularNodosInternos (ab));
	printf ("Calcular Altura 3 = %d\n", CalcularAltura(ab));
	
	printf ("N Elementos  7 = %d\n", CalcularNElementos(ab));
	
	printf ("Equilibrio 1 = %d \n", CalcularEquilibrio(ab));
	
	printf ("Altura Mínima  2 = %d\n", CalcularAlturaMinima(ab));
	
	borrarLista (lista);
	lista = crearLista ();
	printf ("Lista con hermanos ((1, 6), (5, 7)\n");
	CrearListaConHermanos(ab, lista);
	imprimirLista (lista);
	borrarLista (lista);

	lista = crearLista (lista);
	printf ("Lista con hojas (2, 4, 7)\n");
	CrearListaConHojas(ab, lista);
	imprimirLista (lista);
	borrarLista (lista);

	lista = crearLista (lista);
	printf ("Lista con padres (3, 1, 6, 5)\n");
	CrearListaConInternos(ab, lista);
	imprimirLista (lista);
 	borrarLista(lista);

	borrarArbol(ab);

  return 1;
}

